#!/usr/bin/python3
# -*- encoding: utf-8 -*-
'''
Copyright (C) 2011  Joachim Jakob

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
'''
from tkinter import *
from tkinter import messagebox
from tkinter import font
import codecs
import math
##############################################################################################
import sys

sys.path.insert(0, 'daten')
from daten import redm1
##############################################################################################
class Fenster:
    def __init__(self, master):
        frame = Frame(master)
        frame.pack()
        self.frame = Frame(frame)
        self.frame.pack()
        global DefClr
        DefClr = root.cget('background')

        # Labels
        self.l1 = Label(self.frame, text=u'Dieses Programm hilft Dir bei der Bearbeitung des Arbeitshefts Elektronen\u00FCberg\u00E4nge und des Arbeitshefts Organische Redoxreaktionen.')
        self.l1.grid(row=0, rowspan=2, column=0, columnspan=23)
        self.l2 = Label(self.frame, text='Redm').grid(row=3, column=0, columnspan=6)
        self.l3 = Label(self.frame, text='Oxm').grid(row=3, column=6, columnspan=6)
        self.l4 = Label(self.frame, text='Redm').grid(row=3, column=12, columnspan=6)
        self.l5 = Label(self.frame, text='Oxm').grid(row=3, column=18, columnspan=6)
        self.l6 = Label(self.frame, text='Ox.:').grid(row=15, column=0)
        self.l7 = Label(self.frame, text=u'+').grid(row=15, column=6)
        self.l8 = Label(self.frame, text=u'+').grid(row=15, column=9)
        self.l9 = Label(self.frame, text=u'\u2192').grid(row=15, column=12)
        self.l10 = Label(self.frame, text=u'+').grid(row=15, column=15)
        self.l11 = Label(self.frame, text=u'+').grid(row=15, column=18)
        self.l12 = Label(self.frame, text='Red.:').grid(row=16, column=0)
        self.l13 = Label(self.frame, text=u'+').grid(row=16, column=3)
        self.l14 = Label(self.frame, text=u'+').grid(row=16, column=6)
        self.l15 = Label(self.frame, text=u'\u2192').grid(row=16, column=12)
        self.l16 = Label(self.frame, text=u'+').grid(row=16, column=18)
        self.l17 = Label(self.frame, text=u'+').grid(row=16, column=21)
        self.lstrich = Label(self.frame, text='_'*150).grid(row=17, column=1, columnspan=23, sticky=EW)
        self.l18 = Label(self.frame, text=u'+').grid(row=18, column=3)
        self.l19 = Label(self.frame, text=u'+').grid(row=18, column=6)
        self.l20 = Label(self.frame, text=u'+').grid(row=18, column=9)
        self.l21 = Label(self.frame, text=u'\u2192').grid(row=18, column=12)
        self.l22 = Label(self.frame, text=u'+').grid(row=18, column=15)
        self.l23 = Label(self.frame, text=u'+').grid(row=18, column=18)
        self.l24 = Label(self.frame, text=u'+').grid(row=18, column=21)
        self.l25 = Label(self.frame, text='Redm1', foreground='darkgreen').grid(row=19, column=2)
        self.l26 = Label(self.frame, text='Oxm2', foreground='darkred').grid(row=19, column=5)
        self.l27 = Label(self.frame, text='Oxm1', foreground='darkred').grid(row=19, column=14)
        self.l28 = Label(self.frame, text='Redm2', foreground='darkgreen').grid(row=19, column=17)
        self.l29 = Label(self.frame, text=u'+').grid(row=15, column=21)
        self.l30 = Label(self.frame, text=u'+').grid(row=16, column=9)

        # Radiobuttons
        global cR
        cR=StringVar()
        self.r1 = Radiobutton(self.frame, text='Anorganische Chemie', variable=cR, command=self.AuswahlAC, value='ac')
        self.r1.grid(row=2, column=0, columnspan=12)
        #self.r1.select()  
        self.r2 = Radiobutton(self.frame, text='Organische Chemie', variable=cR, command=self.AuswahlOC, value='oc')
        self.r2.grid(row=2, column=12, columnspan=12)

        # Buttons
        self.b1 = Button(self.frame, text='Natrium', command=self.B1, state=DISABLED)
        self.b1.grid(row=4, column=0, columnspan=6, sticky=EW)
        global FontClr
        FontClr = self.b1.cget('disabledforeground')
        self.b2 = Button(self.frame, text='Natriumion', state=DISABLED)
        self.b2.grid(row=4, column=6, columnspan=6, sticky=EW)
        self.b3 = Button(self.frame, text='Aldehyd', command=self.B3, state=DISABLED)
        self.b3.grid(row=4, column=12, columnspan=6, sticky=EW)
        self.b4 = Button(self.frame, text=u'Carbons\u00E4ure', state=DISABLED)
        self.b4.grid(row=4, column=18, columnspan=6, sticky=EW)
        self.b5 = Button(self.frame, text='Wasserstoff', command=self.B5, state=DISABLED)
        self.b5.grid(row=5, column=0, columnspan=6, sticky=EW)
        self.b6 = Button(self.frame, text='Wasser (alkalisch)', command=self.B6, state=DISABLED)
        self.b6.grid(row=5, column=6, columnspan=6, sticky=EW)
        self.b7 = Button(self.frame, text='Kupfer(I)-oxid', command=self.B7, state=DISABLED)
        self.b7.grid(row=5, column=12, columnspan=6, sticky=EW)
        self.b8 = Button(self.frame, text='Kupfer(II)-ion (alkalisch)', command=self.B8, state=DISABLED)
        self.b8.grid(row=5, column=18, columnspan=6, sticky=EW)
        self.b9 = Button(self.frame, text='Zink', command=self.B9, state=DISABLED)
        self.b9.grid(row=6, column=0, columnspan=6, sticky=EW)
        self.b10 = Button(self.frame, text='Zink(II)-ion', command=self.B10, state=DISABLED)
        self.b10.grid(row=6, column=6, columnspan=6, sticky=EW)
        self.b11 = Button(self.frame, text='Silber', command=self.B11, state=DISABLED)
        self.b11.grid(row=6, column=12, columnspan=6, sticky=EW)
        self.b12 = Button(self.frame, text='Silber(I)-ion (alkalisch)', command=self.B12, state=DISABLED)
        self.b12.grid(row=6, column=18, columnspan=6, sticky=EW)
        self.b13 = Button(self.frame, text='Wasserstoff', command=self.B13, state=DISABLED)
        self.b13.grid(row=7, column=0, columnspan=6, sticky=EW)
        self.b14 = Button(self.frame, text='Oxoniumion (sauer)', command=self.B14, state=DISABLED)
        self.b14.grid(row=7, column=6, columnspan=6, sticky=EW)
        self.b15 = Button(self.frame, text=u'prim\u00E4rer Alkohol', command=self.B15, state=DISABLED)
        self.b15.grid(row=7, column=12, columnspan=6, sticky=EW)
        self.b16 = Button(self.frame, text='Aldehyd', command=self.B16, state=DISABLED)
        self.b16.grid(row=7, column=18, columnspan=6, sticky=EW)
        self.b17 = Button(self.frame, text='Kupfer', command=self.B17, state=DISABLED)
        self.b17.grid(row=8, column=0, columnspan=6, sticky=EW)
        self.b18 = Button(self.frame, text='Kupfer(II)-ion', command=self.B18, state=DISABLED)
        self.b18.grid(row=8, column=6, columnspan=6, sticky=EW)
        self.b19 = Button(self.frame, text=u'sekund\u00E4rer Alkohol', command=self.B19, state=DISABLED)
        self.b19.grid(row=8, column=12, columnspan=6, sticky=EW)
        self.b20 = Button(self.frame, text='Keton', command=self.B20, state=DISABLED)
        self.b20.grid(row=8, column=18, columnspan=6, sticky=EW)
        self.b21 = Button(self.frame, text='Mangan(IV)-oxid', command=self.B21, state=DISABLED)
        self.b21.grid(row=9, column=0, columnspan=6, sticky=EW)
        self.b22 = Button(self.frame, text='Permanganation (alkalisch)', command=self.B22, state=DISABLED)
        self.b22.grid(row=9, column=6, columnspan=6, sticky=EW)
        self.b23 = Button(self.frame, text='Kupfer', command=self.B23, state=DISABLED)
        self.b23.grid(row=9, column=12, columnspan=6, sticky=EW)
        self.b24 = Button(self.frame, text='Kupfer(II)-oxid (fest)', command=self.B24, state=DISABLED)
        self.b24.grid(row=9, column=18, columnspan=6, sticky=EW)
        self.b25 = Button(self.frame, text='Chrom(III)-ion', command=self.B25, state=DISABLED)
        self.b25.grid(row=10, column=0, columnspan=6, sticky=EW)
        self.b26 = Button(self.frame, text='Chromation (alkalisch)', command=self.B26, state=DISABLED)
        self.b26.grid(row=10, column=6, columnspan=6, sticky=EW)
        self.b27 = Button(self.frame, text='Chrom(III)-ion', state=DISABLED)
        self.b27.grid(row=10, column=12, columnspan=6, sticky=EW)
        self.b28 = Button(self.frame, text='Dichromation (sauer)', command=self.B28, state=DISABLED)
        self.b28.grid(row=10, column=18, columnspan=6, sticky=EW)
        self.b29 = Button(self.frame, text='Iodidion', command=self.B29, state=DISABLED)
        self.b29.grid(row=11, column=0, columnspan=6, sticky=EW)
        self.b30 = Button(self.frame, text='Iod', command=self.B30, state=DISABLED)
        self.b30.grid(row=11, column=6, columnspan=6, sticky=EW)
        self.b31 = Button(self.frame, text='Bromidion', command=self.B31, state=DISABLED)
        self.b31.grid(row=12, column=0, columnspan=6, sticky=EW)
        self.b32 = Button(self.frame, text='Brom', command=self.B32, state=DISABLED)
        self.b32.grid(row=12, column=6, columnspan=6, sticky=EW)
        self.b33 = Button(self.frame, text='Chloridion', command=self.B33, state=DISABLED)
        self.b33.grid(row=13, column=0, columnspan=6, sticky=EW)
        self.b34 = Button(self.frame, text='Chlor', command=self.B34, state=DISABLED)
        self.b34.grid(row=13, column=6, columnspan=6, sticky=EW)
        self.b35 = Button(self.frame, text='Mangan(II)-ion', state=DISABLED)
        self.b35.grid(row=14, column=0, columnspan=6, sticky=EW)
        self.b36 = Button(self.frame, text='Permanganation (sauer)', command=self.B36, state=DISABLED)
        self.b36.grid(row=14, column=6, columnspan=6, sticky=EW)
        self.b37 = Button(self.frame, text='Reset', command=self.Reset)
        self.b37.grid(row=20, column=0, columnspan=6, sticky=EW)
        self.b38 = Button(self.frame, text='Redoxgleichung ermitteln', command=self.Berechnen, state=DISABLED)
        self.b38.grid(row=20, column=6, columnspan=12, sticky=EW)
        self.b39 = Button(self.frame, text='Beenden', command=frame.quit)
        self.b39.grid(row=20, column=18, columnspan=6, sticky=EW)

        # Entrys
        self.e1 = Entry(self.frame, text='', width=2, background = '#ffffff', state=DISABLED)
        self.e1.grid(row=15, column=1)
        global EntryFontClr
        EntryFontClr = self.e1.cget('disabledforeground')
        global EntryDefClr
        EntryDefClr = self.e1.cget('disabledbackground')
        self.e2 = Entry(self.frame, text='', width=8, background = '#ffffff', state=DISABLED)
        self.e2.grid(row=15, column=2)
        self.e3 = Entry(self.frame, text='', width=2, background = '#ffffff', state=DISABLED)
        self.e3.grid(row=15, column=7)
        self.e4 = Entry(self.frame, text='', width=8, background = '#ffffff', state=DISABLED)
        self.e4.grid(row=15, column=8)
        self.e5 = Entry(self.frame, text='', width=2, background = '#ffffff', state=DISABLED)
        self.e5.grid(row=15, column=10)
        self.e6 = Entry(self.frame, text='', width=8, background = '#ffffff', state=DISABLED)
        self.e6.grid(row=15, column=11)
        self.e7 = Entry(self.frame, text='', width=2, background = '#ffffff', state=DISABLED)
        self.e7.grid(row=15, column=13)
        self.e8 = Entry(self.frame, text='', width=8, background = '#ffffff', state=DISABLED)
        self.e8.grid(row=15, column=14)
        self.e9 = Entry(self.frame, text='', width=2, background = '#ffffff', state=DISABLED)
        self.e9.grid(row=15, column=16)
        self.e10 = Entry(self.frame, text='', width=8, background = '#ffffff', state=DISABLED)
        self.e10.grid(row=15, column=17)
        self.e11 = Entry(self.frame, text='', width=2, background = '#ffffff', state=DISABLED)
        self.e11.grid(row=15, column=19)
        self.e12 = Entry(self.frame, text='', width=8, background = '#ffffff', state=DISABLED)
        self.e12.grid(row=15, column=20)
        self.e13 = Entry(self.frame, text='', width=2, background = '#ffffff', state=DISABLED)
        self.e13.grid(row=16, column=1)
        self.e14 = Entry(self.frame, text='', width=8, background = '#ffffff', state=DISABLED)
        self.e14.grid(row=16, column=2)
        self.e15 = Entry(self.frame, text='', width=2, background = '#ffffff', state=DISABLED)
        self.e15.grid(row=16, column=4)
        self.e16 = Entry(self.frame, text='', width=8, background = '#ffffff', state=DISABLED)
        self.e16.grid(row=16, column=5)
        self.e17 = Entry(self.frame, text='', width=2, background = '#ffffff', state=DISABLED)
        self.e17.grid(row=16, column=7)
        self.e18 = Entry(self.frame, text='', width=8, background = '#ffffff', state=DISABLED)
        self.e18.grid(row=16, column=8)
        self.e19 = Entry(self.frame, text='', width=2, background = '#ffffff', state=DISABLED)
        self.e19.grid(row=16, column=13)
        self.e20 = Entry(self.frame, text='', width=8, background = '#ffffff', state=DISABLED)
        self.e20.grid(row=16, column=14)
        self.e21 = Entry(self.frame, text='', width=2, background = '#ffffff', state=DISABLED)
        self.e21.grid(row=16, column=19)
        self.e22 = Entry(self.frame, text='', width=8, background = '#ffffff', state=DISABLED)
        self.e22.grid(row=16, column=20)
        self.e23 = Entry(self.frame, text='', width=2, background = '#ffffff', state=DISABLED)
        self.e23.grid(row=16, column=22)
        self.e24 = Entry(self.frame, text='', width=8, background = '#ffffff', state=DISABLED)
        self.e24.grid(row=16, column=23)
        self.e25 = Entry(self.frame, text='', width=2, background = '#ffffff', state=DISABLED)
        self.e25.grid(row=18, column=1)
        self.e26 = Entry(self.frame, text='', width=8, background = '#ffffff', state=DISABLED)
        self.e26.grid(row=18, column=2)
        self.e27 = Entry(self.frame, text='', width=2, background = '#ffffff', state=DISABLED)
        self.e27.grid(row=18, column=4)
        self.e28 = Entry(self.frame, text='', width=8, background = '#ffffff', state=DISABLED)
        self.e28.grid(row=18, column=5)
        self.e29 = Entry(self.frame, text='', width=2, background = '#ffffff', state=DISABLED)
        self.e29.grid(row=18, column=7)
        self.e30 = Entry(self.frame, text='', width=8, background = '#ffffff', state=DISABLED)
        self.e30.grid(row=18, column=8)
        self.e31 = Entry(self.frame, text='', width=2, background = '#ffffff', state=DISABLED)
        self.e31.grid(row=18, column=10)
        self.e32 = Entry(self.frame, text='', width=8, background = '#ffffff', state=DISABLED)
        self.e32.grid(row=18, column=11)
        self.e33 = Entry(self.frame, text='', width=2, background = '#ffffff', state=DISABLED)
        self.e33.grid(row=18, column=13)
        self.e34 = Entry(self.frame, text='', width=8, background = '#ffffff', state=DISABLED)
        self.e34.grid(row=18, column=14)
        self.e35 = Entry(self.frame, text='', width=2, background = '#ffffff', state=DISABLED)
        self.e35.grid(row=18, column=16)
        self.e36 = Entry(self.frame, text='', width=8, background = '#ffffff', state=DISABLED)
        self.e36.grid(row=18, column=17)
        self.e37 = Entry(self.frame, text='', width=2, background = '#ffffff', state=DISABLED)
        self.e37.grid(row=18, column=19)
        self.e38 = Entry(self.frame, text='', width=8, background = '#ffffff', state=DISABLED)
        self.e38.grid(row=18, column=20)
        self.e39 = Entry(self.frame, text='', width=2, background = '#ffffff', state=DISABLED)
        self.e39.grid(row=18, column=22)
        self.e40 = Entry(self.frame, text='', width=8, background = '#ffffff', state=DISABLED)
        self.e40.grid(row=18, column=23)
        self.e41 = Entry(self.frame, text='', width=2, background = '#ffffff', state=DISABLED)
        self.e41.grid(row=15, column=22)
        self.e42 = Entry(self.frame, text='', width=8, background = '#ffffff', state=DISABLED)
        self.e42.grid(row=15, column=23)
        self.e43 = Entry(self.frame, text='', width=2, background = '#ffffff', state=DISABLED)
        self.e43.grid(row=16, column=10)
        self.e44 = Entry(self.frame, text='', width=8, background = '#ffffff', state=DISABLED)
        self.e44.grid(row=16, column=11)

        global Milieu
        Milieu='alkalisch'

##############################################################################################
    def AuswahlAC(self):
        Auswahlwert=cR.get()
        #print 'Auswahl',Auswahlwert
        self.r2.config(state=DISABLED)
        self.r1.config(state=DISABLED)
        #AC Redm
        self.b1.config(state=NORMAL)
        self.b5.config(state=NORMAL)
        self.b9.config(state=NORMAL)
        self.b13.config(state=NORMAL)
        self.b17.config(state=NORMAL)
        self.b21.config(state=NORMAL)
        self.b25.config(state=NORMAL)
        self.b29.config(state=NORMAL)
        self.b31.config(state=NORMAL)
        self.b33.config(state=NORMAL)
        self.b35.config(state=DISABLED)
        #OC Redm
        self.b3.config(state=DISABLED)
        self.b7.config(state=DISABLED)
        self.b11.config(state=DISABLED)
        self.b15.config(state=DISABLED)
        self.b19.config(state=DISABLED)
        self.b23.config(state=DISABLED)
        self.b27.config(state=DISABLED)
        #OC Oxm
        self.b4.config(state=DISABLED)
        self.b8.config(state=DISABLED)
        self.b12.config(state=DISABLED)
        self.b16.config(state=DISABLED)
        self.b20.config(state=DISABLED)
        self.b24.config(state=DISABLED)
        self.b28.config(state=DISABLED)

    def AuswahlOC(self):
        Auswahlwert=cR.get()
        #print 'Auswahl',Auswahlwert
        self.r1.config(state=DISABLED)
        self.r2.config(state=DISABLED)
        #AC Redm
        self.b1.config(state=DISABLED)
        self.b5.config(state=DISABLED)
        self.b9.config(state=DISABLED)
        self.b13.config(state=DISABLED)
        self.b17.config(state=DISABLED)
        self.b21.config(state=DISABLED)
        self.b25.config(state=DISABLED)
        self.b29.config(state=DISABLED)
        self.b31.config(state=DISABLED)
        self.b33.config(state=DISABLED)
        self.b35.config(state=DISABLED)
        #AC Oxm
        self.b2.config(state=DISABLED)
        self.b6.config(state=DISABLED)
        self.b10.config(state=DISABLED)
        self.b14.config(state=DISABLED)
        self.b18.config(state=DISABLED)
        self.b22.config(state=DISABLED)
        self.b26.config(state=DISABLED)
        self.b30.config(state=DISABLED)
        self.b32.config(state=DISABLED)
        self.b34.config(state=DISABLED)
        self.b36.config(state=DISABLED)
        #OC Redm
        self.b3.config(state=NORMAL)
        self.b7.config(state=NORMAL)
        self.b11.config(state=NORMAL)
        self.b15.config(state=NORMAL)
        self.b19.config(state=NORMAL)
        self.b23.config(state=NORMAL)
        self.b27.config(state=DISABLED) 

    def B1(self):
        #print "B1"
        #AC Redm
        self.b1.config(state=DISABLED)
        self.b1.config(background='darkgreen', disabledforeground='white')
        self.b5.config(state=DISABLED)
        self.b9.config(state=DISABLED)
        self.b13.config(state=DISABLED)
        self.b17.config(state=DISABLED)
        self.b21.config(state=DISABLED)
        self.b25.config(state=DISABLED)
        self.b29.config(state=DISABLED)
        self.b31.config(state=DISABLED)
        self.b33.config(state=DISABLED)
        self.b35.config(state=DISABLED)
        #AC Oxm
        self.b2.config(state=DISABLED)
        self.b6.config(state=NORMAL)
        self.b10.config(state=NORMAL)
        self.b14.config(state=NORMAL)
        self.b18.config(state=NORMAL)
        self.b22.config(state=NORMAL)
        self.b26.config(state=NORMAL)
        self.b30.config(state=NORMAL)
        self.b32.config(state=NORMAL)
        self.b34.config(state=NORMAL)
        self.b36.config(state=NORMAL)
        self.b2.config(background='darkred', disabledforeground='white')
        global Reduktionsmittel1
        Reduktionsmittel1='Natrium'
        global Oxidationsmittel1
        Oxidationsmittel1='Natriumion'

    #def B2(self):
        #print "B2"

    def B3(self):
        #print "B3"
        #OC Redm
        self.b3.config(state=DISABLED)
        self.b3.config(background='darkgreen', disabledforeground='white')
        self.b7.config(state=DISABLED)
        self.b11.config(state=DISABLED)
        self.b15.config(state=DISABLED)
        self.b19.config(state=DISABLED)
        self.b23.config(state=DISABLED)
        self.b27.config(state=DISABLED)
        #OC Oxm
        self.b4.config(state=DISABLED)
        self.b8.config(state=NORMAL)
        self.b12.config(state=NORMAL)
        self.b16.config(state=NORMAL)
        self.b20.config(state=NORMAL)
        self.b24.config(state=NORMAL)
        self.b28.config(state=NORMAL)
        self.b4.config(background='darkred', disabledforeground='white')
        global Reduktionsmittel1
        Reduktionsmittel1='Aldehyd'
        global Oxidationsmittel1
        Oxidationsmittel1='Carbonsaeure'

    #def B4(self):
        #print "B4"

    def B5(self):
        #print "B5"
        #AC Redm
        self.b1.config(state=DISABLED)
        self.b5.config(state=DISABLED)
        self.b5.config(background='darkgreen', disabledforeground='white')
        self.b9.config(state=DISABLED)
        self.b13.config(state=DISABLED)
        self.b17.config(state=DISABLED)
        self.b21.config(state=DISABLED)
        self.b25.config(state=DISABLED)
        self.b29.config(state=DISABLED)
        self.b31.config(state=DISABLED)
        self.b33.config(state=DISABLED)
        self.b35.config(state=DISABLED)
        #AC Oxm
        self.b2.config(state=DISABLED)
        self.b6.config(state=DISABLED)
        self.b10.config(state=NORMAL)
        self.b14.config(state=DISABLED)
        self.b18.config(state=NORMAL)
        self.b22.config(state=NORMAL)
        self.b26.config(state=NORMAL)
        self.b30.config(state=NORMAL)
        self.b32.config(state=NORMAL)
        self.b34.config(state=NORMAL)
        self.b36.config(state=DISABLED)
        self.b6.config(background='darkred', disabledforeground='white')
        global Reduktionsmittel1
        Reduktionsmittel1='Wasserstoff'
        global Oxidationsmittel1
        Oxidationsmittel1='Wasser'
        global Milieu
        Milieu='alkalisch'

    def B6(self):
        #print "B6"
        #AC Oxm
        self.b2.config(state=DISABLED)
        self.b6.config(state=DISABLED)
        self.b6.config(background='darkred', disabledforeground='white')
        self.b10.config(state=DISABLED)
        self.b14.config(state=DISABLED)
        self.b18.config(state=DISABLED)
        self.b22.config(state=DISABLED)
        self.b26.config(state=DISABLED)
        self.b30.config(state=DISABLED)
        self.b32.config(state=DISABLED)
        self.b34.config(state=DISABLED)
        self.b36.config(state=DISABLED)
        self.b5.config(background='darkgreen', disabledforeground='white')
        global Reduktionsmittel2
        Reduktionsmittel2='Wasserstoff'
        global Oxidationsmittel2
        Oxidationsmittel2='Wasser'
        global Milieu
        Milieu='alkalisch'
        self.b38.config(state=NORMAL)

    def B7(self):
        #print "B7"
        #OC Redm
        self.b3.config(state=DISABLED)
        self.b7.config(state=DISABLED)
        self.b7.config(background='darkgreen', disabledforeground='white')
        self.b11.config(state=DISABLED)
        self.b15.config(state=DISABLED)
        self.b19.config(state=DISABLED)
        self.b23.config(state=DISABLED)
        self.b27.config(state=DISABLED)
        #OC Oxm
        self.b4.config(state=DISABLED)
        self.b8.config(state=DISABLED)
        self.b12.config(state=NORMAL)
        self.b16.config(state=NORMAL)
        self.b20.config(state=NORMAL)
        self.b24.config(state=NORMAL)
        self.b28.config(state=DISABLED)
        self.b8.config(background='darkred', disabledforeground='white')
        global Reduktionsmittel1
        Reduktionsmittel1='Kupfer(I)-oxid'
        global Oxidationsmittel1
        Oxidationsmittel1='Kupfer(II)-ion'
        global Milieu
        Milieu='alkalisch'

    def B8(self):
        #print "B8"
        #OC Oxm
        self.b4.config(state=DISABLED)
        self.b8.config(state=DISABLED)
        self.b8.config(background='darkred', disabledforeground='white')
        self.b12.config(state=DISABLED)
        self.b16.config(state=DISABLED)
        self.b20.config(state=DISABLED)
        self.b24.config(state=DISABLED)
        self.b28.config(state=DISABLED)
        self.b7.config(background='darkgreen', disabledforeground='white')
        global Reduktionsmittel2
        Reduktionsmittel2='Kupfer(I)-oxid'
        global Oxidationsmittel2
        Oxidationsmittel2='Kupfer(II)-ion'
        global Milieu
        Milieu='alkalisch'
        self.b38.config(state=NORMAL)

    def B9(self):
        #print "B9"
        #AC Redm
        self.b1.config(state=DISABLED)
        self.b5.config(state=DISABLED)
        self.b9.config(state=DISABLED)
        self.b9.config(background='darkgreen', disabledforeground='white')
        self.b13.config(state=DISABLED)
        self.b17.config(state=DISABLED)
        self.b21.config(state=DISABLED)
        self.b25.config(state=DISABLED)
        self.b29.config(state=DISABLED)
        self.b31.config(state=DISABLED)
        self.b33.config(state=DISABLED)
        self.b35.config(state=DISABLED)
        #AC Oxm
        self.b2.config(state=DISABLED)
        self.b6.config(state=DISABLED)
        self.b10.config(state=DISABLED)
        self.b14.config(state=NORMAL)
        self.b18.config(state=NORMAL)
        self.b22.config(state=NORMAL)
        self.b26.config(state=NORMAL)
        self.b30.config(state=NORMAL)
        self.b32.config(state=NORMAL)
        self.b34.config(state=NORMAL)
        self.b36.config(state=NORMAL)
        self.b10.config(background='darkred', disabledforeground='white')
        global Reduktionsmittel1
        Reduktionsmittel1='Zink'
        global Oxidationsmittel1
        Oxidationsmittel1='Zink(II)-ion'

    def B10(self):
        #print "B10"
        #AC Oxm
        self.b2.config(state=DISABLED)
        self.b6.config(state=DISABLED)
        self.b10.config(state=DISABLED)
        self.b10.config(background='darkred', disabledforeground='white')
        self.b14.config(state=DISABLED)
        self.b18.config(state=DISABLED)
        self.b22.config(state=DISABLED)
        self.b26.config(state=DISABLED)
        self.b30.config(state=DISABLED)
        self.b32.config(state=DISABLED)
        self.b34.config(state=DISABLED)
        self.b36.config(state=DISABLED)
        self.b9.config(background='darkgreen', disabledforeground='white')
        global Reduktionsmittel2
        Reduktionsmittel2='Zink'
        global Oxidationsmittel2
        Oxidationsmittel2='Zink(II)-ion'
        self.b38.config(state=NORMAL)

    def B11(self):
        #print "B11"
        #OC Redm
        self.b3.config(state=DISABLED)
        self.b7.config(state=DISABLED)
        self.b11.config(state=DISABLED)
        self.b11.config(background='darkgreen', disabledforeground='white')
        self.b15.config(state=DISABLED)
        self.b19.config(state=DISABLED)
        self.b23.config(state=DISABLED)
        self.b27.config(state=DISABLED)
        #OC Oxm
        self.b4.config(state=DISABLED)
        self.b8.config(state=DISABLED)
        self.b12.config(state=DISABLED)
        self.b16.config(state=NORMAL)
        self.b20.config(state=NORMAL)
        self.b24.config(state=NORMAL)
        self.b28.config(state=DISABLED)
        self.b12.config(background='darkred', disabledforeground='white')
        global Reduktionsmittel1
        Reduktionsmittel1='Silber'
        global Oxidationsmittel1
        Oxidationsmittel1='Silber(I)-ion'
        global Milieu
        Milieu='alkalisch'

    def B12(self):
        #print "B12"
        #OC Oxm
        self.b4.config(state=DISABLED)
        self.b8.config(state=DISABLED)
        self.b12.config(state=DISABLED)
        self.b12.config(background='darkred', disabledforeground='white')
        self.b16.config(state=DISABLED)
        self.b20.config(state=DISABLED)
        self.b24.config(state=DISABLED)
        self.b28.config(state=DISABLED)
        self.b11.config(background='darkgreen', disabledforeground='white')
        global Reduktionsmittel2
        Reduktionsmittel2='Silber'
        global Oxidationsmittel2
        Oxidationsmittel2='Silber(I)-ion'
        global Milieu
        Milieu='alkalisch'
        self.b38.config(state=NORMAL)

    def B13(self):
        #print "B13"
        #AC Redm
        self.b1.config(state=DISABLED)
        self.b5.config(state=DISABLED)
        self.b9.config(state=DISABLED)
        self.b13.config(state=DISABLED)
        self.b13.config(background='darkgreen', disabledforeground='white')
        self.b17.config(state=DISABLED)
        self.b21.config(state=DISABLED)
        self.b25.config(state=DISABLED)
        self.b29.config(state=DISABLED)
        self.b31.config(state=DISABLED)
        self.b33.config(state=DISABLED)
        self.b35.config(state=DISABLED)
        #AC Oxm
        self.b2.config(state=DISABLED)
        self.b6.config(state=DISABLED)
        self.b10.config(state=DISABLED)
        self.b14.config(state=DISABLED)
        self.b18.config(state=NORMAL)
        self.b22.config(state=NORMAL)
        self.b26.config(state=NORMAL)
        self.b30.config(state=NORMAL)
        self.b32.config(state=NORMAL)
        self.b34.config(state=NORMAL)
        self.b36.config(state=NORMAL)
        self.b14.config(background='darkred', disabledforeground='white')
        global Reduktionsmittel1
        Reduktionsmittel1='Wasserstoff'
        global Oxidationsmittel1
        Oxidationsmittel1='Oxoniumion'
        global Milieu
        Milieu='sauer'

    def B14(self):
        #print "B14"
        #AC Oxm
        self.b2.config(state=DISABLED)
        self.b6.config(state=DISABLED)
        self.b10.config(state=DISABLED)
        self.b14.config(state=DISABLED)
        self.b14.config(background='darkred', disabledforeground='white')
        self.b18.config(state=DISABLED)
        self.b22.config(state=DISABLED)
        self.b26.config(state=DISABLED)
        self.b30.config(state=DISABLED)
        self.b32.config(state=DISABLED)
        self.b34.config(state=DISABLED)
        self.b36.config(state=DISABLED)
        self.b13.config(background='darkgreen', disabledforeground='white')
        global Reduktionsmittel2
        Reduktionsmittel2='Wasserstoff'
        global Oxidationsmittel2
        Oxidationsmittel2='Oxoniumion'
        global Milieu
        Milieu='sauer'
        self.b38.config(state=NORMAL)

    def B15(self):
        #print "B15"
        #OC Redm
        self.b3.config(state=DISABLED)
        self.b7.config(state=DISABLED)
        self.b11.config(state=DISABLED)
        self.b15.config(state=DISABLED)
        self.b15.config(background='darkgreen', disabledforeground='white')
        self.b19.config(state=DISABLED)
        self.b23.config(state=DISABLED)
        self.b27.config(state=DISABLED)
        #OC Oxm
        self.b4.config(state=DISABLED)
        self.b8.config(state=DISABLED)
        self.b12.config(state=DISABLED)
        self.b16.config(state=DISABLED)
        self.b20.config(state=NORMAL)
        self.b24.config(state=NORMAL)
        self.b28.config(state=NORMAL)
        self.b16.config(background='darkred', disabledforeground='white')
        global Reduktionsmittel1
        Reduktionsmittel1='primaerer Alkohol'
        global Oxidationsmittel1
        Oxidationsmittel1='Aldehyd'

    def B16(self):
        #print "B16"
        #OC Oxm
        self.b4.config(state=DISABLED)
        self.b8.config(state=DISABLED)
        self.b12.config(state=DISABLED)
        self.b16.config(state=DISABLED)
        self.b16.config(background='darkred', disabledforeground='white')
        self.b20.config(state=DISABLED)
        self.b24.config(state=DISABLED)
        self.b28.config(state=DISABLED)
        self.b15.config(background='darkgreen', disabledforeground='white')
        global Reduktionsmittel2
        Reduktionsmittel2='primaerer Alkohol'
        global Oxidationsmittel2
        Oxidationsmittel2='Aldehyd'
        self.b38.config(state=NORMAL)

    def B17(self):
        #print "B17"
        #AC Redm
        self.b1.config(state=DISABLED)
        self.b5.config(state=DISABLED)
        self.b9.config(state=DISABLED)
        self.b13.config(state=DISABLED)
        self.b17.config(state=DISABLED)
        self.b17.config(background='darkgreen', disabledforeground='white')
        self.b21.config(state=DISABLED)
        self.b25.config(state=DISABLED)
        self.b29.config(state=DISABLED)
        self.b31.config(state=DISABLED)
        self.b33.config(state=DISABLED)
        self.b35.config(state=DISABLED)
        #AC Oxm
        self.b2.config(state=DISABLED)
        self.b6.config(state=DISABLED)
        self.b10.config(state=DISABLED)
        self.b14.config(state=DISABLED)
        self.b18.config(state=DISABLED)
        self.b22.config(state=NORMAL)
        self.b26.config(state=NORMAL)
        self.b30.config(state=NORMAL)
        self.b32.config(state=NORMAL)
        self.b34.config(state=NORMAL)
        self.b36.config(state=NORMAL)
        self.b18.config(background='darkred')
        global Reduktionsmittel1
        Reduktionsmittel1='Kupfer'
        global Oxidationsmittel1
        Oxidationsmittel1='Kupfer(II)-ion'

    def B18(self):
        #print "B18"
        #AC Oxm
        self.b2.config(state=DISABLED)
        self.b6.config(state=DISABLED)
        self.b10.config(state=DISABLED)
        self.b14.config(state=DISABLED)
        self.b18.config(state=DISABLED)
        self.b18.config(background='darkred', disabledforeground='white')
        self.b22.config(state=DISABLED)
        self.b26.config(state=DISABLED)
        self.b30.config(state=DISABLED)
        self.b32.config(state=DISABLED)
        self.b34.config(state=DISABLED)
        self.b36.config(state=DISABLED)
        self.b17.config(background='darkgreen', disabledforeground='white')
        global Reduktionsmittel2
        Reduktionsmittel2='Kupfer'
        global Oxidationsmittel2
        Oxidationsmittel2='Kupfer(II)-ion'
        self.b38.config(state=NORMAL)

    def B19(self):
        #print "B19"
        #OC Redm
        self.b3.config(state=DISABLED)
        self.b7.config(state=DISABLED)
        self.b11.config(state=DISABLED)
        self.b15.config(state=DISABLED)
        self.b19.config(state=DISABLED)
        self.b19.config(background='darkgreen', disabledforeground='white')
        self.b23.config(state=DISABLED)
        self.b27.config(state=DISABLED)
        #OC Oxm
        self.b4.config(state=DISABLED)
        self.b8.config(state=DISABLED)
        self.b12.config(state=DISABLED)
        self.b16.config(state=DISABLED)
        self.b20.config(state=DISABLED)
        self.b24.config(state=NORMAL)
        self.b28.config(state=NORMAL)
        self.b20.config(background='darkred', disabledforeground='white')
        global Reduktionsmittel1
        Reduktionsmittel1='sekundaerer Alkohol'
        global Oxidationsmittel1
        Oxidationsmittel1='Keton'

    def B20(self):
        #print "B20"
        #OC Oxm
        self.b4.config(state=DISABLED)
        self.b8.config(state=DISABLED)
        self.b12.config(state=DISABLED)
        self.b16.config(state=DISABLED)
        self.b20.config(background='darkred', disabledforeground='white')
        self.b20.config(state=DISABLED)
        self.b24.config(state=DISABLED)
        self.b28.config(state=DISABLED)
        self.b19.config(background='darkgreen', disabledforeground='white')
        global Reduktionsmittel2
        Reduktionsmittel2='sekundaerer Alkohol'
        global Oxidationsmittel2
        Oxidationsmittel2='Keton'
        self.b38.config(state=NORMAL)

    def B21(self):
        #print "B21"
        #AC Redm
        self.b1.config(state=DISABLED)
        self.b5.config(state=DISABLED)
        self.b9.config(state=DISABLED)
        self.b13.config(state=DISABLED)
        self.b17.config(state=DISABLED)
        self.b21.config(state=DISABLED)
        self.b21.config(background='darkgreen', disabledforeground='white')
        self.b25.config(state=DISABLED)
        self.b29.config(state=DISABLED)
        self.b31.config(state=DISABLED)
        self.b33.config(state=DISABLED)
        self.b35.config(state=DISABLED)
        #AC Oxm
        self.b2.config(state=DISABLED)
        self.b6.config(state=DISABLED)
        self.b10.config(state=DISABLED)
        self.b14.config(state=DISABLED)
        self.b18.config(state=DISABLED)
        self.b22.config(state=DISABLED)
        self.b26.config(state=NORMAL)
        self.b30.config(state=NORMAL)
        self.b32.config(state=NORMAL)
        self.b34.config(state=NORMAL)
        self.b36.config(state=DISABLED)
        self.b22.config(background='darkred', disabledforeground='white')
        global Reduktionsmittel1
        Reduktionsmittel1='Mangan(IV)-oxid'
        global Oxidationsmittel1
        Oxidationsmittel1='Permanganation'
        global Milieu
        Milieu='alkalisch'

    def B22(self):
        #print "B22"
        #AC Oxm
        self.b2.config(state=DISABLED)
        self.b6.config(state=DISABLED)
        self.b10.config(state=DISABLED)
        self.b14.config(state=DISABLED)
        self.b18.config(state=DISABLED)
        self.b22.config(state=DISABLED)
        self.b22.config(background='darkred', disabledforeground='white')
        self.b26.config(state=DISABLED)
        self.b30.config(state=DISABLED)
        self.b32.config(state=DISABLED)
        self.b34.config(state=DISABLED)
        self.b36.config(state=DISABLED)
        self.b21.config(background='darkgreen', disabledforeground='white')
        global Reduktionsmittel2
        Reduktionsmittel2='Mangan(IV)-oxid'
        global Oxidationsmittel2
        Oxidationsmittel2='Permanganation'
        global Milieu
        Milieu='alkalisch'
        self.b38.config(state=NORMAL)

    def B23(self):
        #print "B23"
        #OC Redm
        self.b3.config(state=DISABLED)
        self.b7.config(state=DISABLED)
        self.b11.config(state=DISABLED)
        self.b15.config(state=DISABLED)
        self.b19.config(state=DISABLED)
        self.b23.config(state=DISABLED)
        self.b23.config(background='darkgreen', disabledforeground='white')
        self.b27.config(state=DISABLED)
        #OC Oxm
        self.b4.config(state=DISABLED)
        self.b8.config(state=DISABLED)
        self.b12.config(state=DISABLED)
        self.b16.config(state=DISABLED)
        self.b20.config(state=DISABLED)
        self.b24.config(state=DISABLED)
        self.b28.config(state=NORMAL)
        self.b24.config(background='darkred', disabledforeground='white')
        global Reduktionsmittel1
        Reduktionsmittel1='Kupfer'
        global Oxidationsmittel1
        Oxidationsmittel1='Kupfer(II)-oxid'

    def B24(self):
        #print "B24"
        #OC Oxm
        self.b4.config(state=DISABLED)
        self.b8.config(state=DISABLED)
        self.b12.config(state=DISABLED)
        self.b16.config(state=DISABLED)
        self.b20.config(state=DISABLED)
        self.b24.config(state=DISABLED)
        self.b24.config(background='darkred', disabledforeground='white')
        self.b28.config(state=DISABLED)
        self.b23.config(background='darkgreen', disabledforeground='white')
        global Reduktionsmittel2
        Reduktionsmittel2='Kupfer'
        global Oxidationsmittel2
        Oxidationsmittel2='Kupfer(II)-oxid'
        self.b38.config(state=NORMAL)

    def B25(self):
        #print "B25"
        #AC Redm
        self.b1.config(state=DISABLED)
        self.b5.config(state=DISABLED)
        self.b9.config(state=DISABLED)
        self.b13.config(state=DISABLED)
        self.b17.config(state=DISABLED)
        self.b21.config(state=DISABLED)
        self.b25.config(state=DISABLED)
        self.b25.config(background='darkgreen', disabledforeground='white')
        self.b29.config(state=DISABLED)
        self.b31.config(state=DISABLED)
        self.b33.config(state=DISABLED)
        self.b35.config(state=DISABLED)
        #AC Oxm
        self.b2.config(state=DISABLED)
        self.b6.config(state=DISABLED)
        self.b10.config(state=DISABLED)
        self.b14.config(state=DISABLED)
        self.b18.config(state=DISABLED)
        self.b22.config(state=DISABLED)
        self.b26.config(state=DISABLED)
        self.b30.config(state=NORMAL)
        self.b32.config(state=NORMAL)
        self.b34.config(state=NORMAL)
        self.b36.config(state=DISABLED)
        self.b26.config(background='darkred', disabledforeground='white')
        global Reduktionsmittel1
        Reduktionsmittel1='Chrom(III)-ion'
        global Oxidationsmittel1
        Oxidationsmittel1='Chromation'
        global Milieu
        Milieu='alkalisch'

    def B26(self):
        #print "B26"
        #AC Oxm
        self.b2.config(state=DISABLED)
        self.b6.config(state=DISABLED)
        self.b10.config(state=DISABLED)
        self.b14.config(state=DISABLED)
        self.b18.config(state=DISABLED)
        self.b22.config(state=DISABLED)
        self.b26.config(state=DISABLED)
        self.b26.config(background='darkred', disabledforeground='white')
        self.b30.config(state=DISABLED)
        self.b32.config(state=DISABLED)
        self.b34.config(state=DISABLED)
        self.b36.config(state=DISABLED)
        self.b25.config(background='darkgreen', disabledforeground='white')
        global Reduktionsmittel2
        Reduktionsmittel2='Chrom(III)-ion'
        global Oxidationsmittel2
        Oxidationsmittel2='Chromation'
        global Milieu
        Milieu='alkalisch'
        self.b38.config(state=NORMAL)

    #def B27(self):
        #print "B27"

    def B28(self):
        #print "B28"
        #OC Oxm
        self.b4.config(state=DISABLED)
        self.b8.config(state=DISABLED)
        self.b12.config(state=DISABLED)
        self.b16.config(state=DISABLED)
        self.b20.config(state=DISABLED)
        self.b24.config(state=DISABLED)
        self.b28.config(state=DISABLED)
        self.b28.config(background='darkred', disabledforeground='white')
        self.b27.config(background='darkgreen', disabledforeground='white')
        global Reduktionsmittel2
        Reduktionsmittel2='Chrom(III)-ion'
        global Oxidationsmittel2
        Oxidationsmittel2='Dichromation'
        global Milieu
        Milieu='sauer'
        self.b38.config(state=NORMAL)

    def B29(self):
        #print "B29"
        #AC Redm
        self.b1.config(state=DISABLED)
        self.b5.config(state=DISABLED)
        self.b9.config(state=DISABLED)
        self.b13.config(state=DISABLED)
        self.b17.config(state=DISABLED)
        self.b21.config(state=DISABLED)
        self.b25.config(state=DISABLED)
        self.b29.config(state=DISABLED)
        self.b29.config(background='darkgreen', disabledforeground='white')
        self.b31.config(state=DISABLED)
        self.b33.config(state=DISABLED)
        self.b35.config(state=DISABLED)
        #AC Oxm
        self.b2.config(state=DISABLED)
        self.b6.config(state=DISABLED)
        self.b10.config(state=DISABLED)
        self.b14.config(state=DISABLED)
        self.b18.config(state=DISABLED)
        self.b22.config(state=DISABLED)
        self.b26.config(state=DISABLED)
        self.b30.config(state=DISABLED)
        self.b32.config(state=NORMAL)
        self.b34.config(state=NORMAL)
        self.b36.config(state=NORMAL)
        self.b30.config(background='darkred', disabledforeground='white')
        global Reduktionsmittel1
        Reduktionsmittel1='Iodidion'
        global Oxidationsmittel1
        Oxidationsmittel1='Iod'

    def B30(self):
        #print "B30"
        #AC Oxm
        self.b2.config(state=DISABLED)
        self.b6.config(state=DISABLED)
        self.b10.config(state=DISABLED)
        self.b14.config(state=DISABLED)
        self.b18.config(state=DISABLED)
        self.b22.config(state=DISABLED)
        self.b26.config(state=DISABLED)
        self.b30.config(state=DISABLED)
        self.b30.config(background='darkred', disabledforeground='white')
        self.b32.config(state=DISABLED)
        self.b34.config(state=DISABLED)
        self.b36.config(state=DISABLED)
        self.b29.config(background='darkgreen', disabledforeground='white')
        global Reduktionsmittel2
        Reduktionsmittel2='Iodidion'
        global Oxidationsmittel2
        Oxidationsmittel2='Iod'
        self.b38.config(state=NORMAL)

    def B31(self):
        #print "B31"
        #AC Redm
        self.b1.config(state=DISABLED)
        self.b5.config(state=DISABLED)
        self.b9.config(state=DISABLED)
        self.b13.config(state=DISABLED)
        self.b17.config(state=DISABLED)
        self.b21.config(state=DISABLED)
        self.b25.config(state=DISABLED)
        self.b29.config(state=DISABLED)
        self.b31.config(state=DISABLED)
        self.b31.config(background='darkgreen', disabledforeground='white')
        self.b33.config(state=DISABLED)
        self.b35.config(state=DISABLED)
        #AC Oxm
        self.b2.config(state=DISABLED)
        self.b6.config(state=DISABLED)
        self.b10.config(state=DISABLED)
        self.b14.config(state=DISABLED)
        self.b18.config(state=DISABLED)
        self.b22.config(state=DISABLED)
        self.b26.config(state=DISABLED)
        self.b30.config(state=DISABLED)
        self.b32.config(state=DISABLED)
        self.b34.config(state=NORMAL)
        self.b36.config(state=NORMAL)
        self.b32.config(background='darkred', disabledforeground='white')
        global Reduktionsmittel1
        Reduktionsmittel1='Bromidion'
        global Oxidationsmittel1
        Oxidationsmittel1='Brom'

    def B32(self):
        #print "B32"
        #AC Oxm
        self.b2.config(state=DISABLED)
        self.b6.config(state=DISABLED)
        self.b10.config(state=DISABLED)
        self.b14.config(state=DISABLED)
        self.b18.config(state=DISABLED)
        self.b22.config(state=DISABLED)
        self.b26.config(state=DISABLED)
        self.b30.config(state=DISABLED)
        self.b32.config(state=DISABLED)
        self.b32.config(background='darkred', disabledforeground='white')
        self.b34.config(state=DISABLED)
        self.b36.config(state=DISABLED)
        self.b31.config(background='darkgreen', disabledforeground='white')
        global Reduktionsmittel2
        Reduktionsmittel2='Bromidion'
        global Oxidationsmittel2
        Oxidationsmittel2='Brom'
        self.b38.config(state=NORMAL)

    def B33(self):
        #print "B33"
        #AC Redm
        self.b1.config(state=DISABLED)
        self.b5.config(state=DISABLED)
        self.b9.config(state=DISABLED)
        self.b13.config(state=DISABLED)
        self.b17.config(state=DISABLED)
        self.b21.config(state=DISABLED)
        self.b25.config(state=DISABLED)
        self.b29.config(state=DISABLED)
        self.b31.config(state=DISABLED)
        self.b33.config(state=DISABLED)
        self.b33.config(background='darkgreen', disabledforeground='white')
        self.b35.config(state=DISABLED)
        #AC Oxm
        self.b2.config(state=DISABLED)
        self.b6.config(state=DISABLED)
        self.b10.config(state=DISABLED)
        self.b14.config(state=DISABLED)
        self.b18.config(state=DISABLED)
        self.b22.config(state=DISABLED)
        self.b26.config(state=DISABLED)
        self.b30.config(state=DISABLED)
        self.b32.config(state=DISABLED)
        self.b34.config(state=DISABLED)
        self.b36.config(state=NORMAL)
        self.b34.config(background='darkred', disabledforeground='white')
        global Reduktionsmittel1
        Reduktionsmittel1='Chloridion'
        global Oxidationsmittel1
        Oxidationsmittel1='Chlor'

    def B34(self):
        #print "B34"
        #AC Oxm
        self.b2.config(state=DISABLED)
        self.b6.config(state=DISABLED)
        self.b10.config(state=DISABLED)
        self.b14.config(state=DISABLED)
        self.b18.config(state=DISABLED)
        self.b22.config(state=DISABLED)
        self.b26.config(state=DISABLED)
        self.b30.config(state=DISABLED)
        self.b32.config(state=DISABLED)
        self.b34.config(state=DISABLED)
        self.b34.config(background='darkred', disabledforeground='white')
        self.b36.config(state=DISABLED)
        self.b33.config(background='darkgreen', disabledforeground='white')
        global Reduktionsmittel2
        Reduktionsmittel2='Chloridion'
        global Oxidationsmittel2
        Oxidationsmittel2='Chlor'
        self.b38.config(state=NORMAL)

    #def B35(self):
        #print "B35"

    def B36(self):
        #print "B36"
        #AC Oxm
        self.b2.config(state=DISABLED)
        self.b6.config(state=DISABLED)
        self.b10.config(state=DISABLED)
        self.b14.config(state=DISABLED)
        self.b18.config(state=DISABLED)
        self.b22.config(state=DISABLED)
        self.b26.config(state=DISABLED)
        self.b30.config(state=DISABLED)
        self.b32.config(state=DISABLED)
        self.b34.config(state=DISABLED)
        self.b36.config(state=DISABLED)
        self.b36.config(background='darkred', disabledforeground='white')
        self.b35.config(background='darkgreen', disabledforeground='white')
        global Reduktionsmittel2
        Reduktionsmittel2='Mangan(II)-ion'
        global Oxidationsmittel2
        Oxidationsmittel2='Permanganation'
        global Milieu
        Milieu='sauer'
        self.b38.config(state=NORMAL)

    def Berechnen(self):
        #print "Berechnen"
        #print Reduktionsmittel1,'reagiert mit',Oxidationsmittel2,'zu',Oxidationsmittel1,'und',Reduktionsmittel2
        #print 'Das Milieu ist',Milieu
        self.Reduktionsteilgleichung()
        self.Oxidationsteilgleichung()
        self.Gesamtgleichung()

    def Reset(self):
        #print "Reset"
        self.r2.config(state=NORMAL)
        self.r1.config(state=NORMAL)
        self.r2.deselect()
        self.r1.deselect()
        #AC Redm
        self.b1.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b5.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b9.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b13.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b17.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b21.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b25.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b29.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b31.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b33.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b35.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        #AC Oxm
        self.b2.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b6.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b10.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b14.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b18.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b22.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b26.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b30.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b32.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b34.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b36.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        #OC Redm
        self.b3.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b7.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b11.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b15.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b19.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b23.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b27.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        #OC Oxm
        self.b4.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b8.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b12.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b16.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b20.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b24.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        self.b28.config(background=DefClr, disabledforeground=FontClr, state=DISABLED)
        global Milieu
        Milieu='sauer'
        self.b38.config(state=DISABLED)
        # Reset Entry
        self.e1.config(state=NORMAL)
        self.e1.delete(0, END)
        self.e1.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e2.config(state=NORMAL)
        self.e2.delete(0, END)
        self.e2.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e3.config(state=NORMAL)
        self.e3.delete(0, END)
        self.e3.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e4.config(state=NORMAL)
        self.e4.delete(0, END)
        self.e4.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e5.config(state=NORMAL)
        self.e5.delete(0, END)
        self.e5.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e6.config(state=NORMAL)
        self.e6.delete(0, END)
        self.e6.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e7.config(state=NORMAL)
        self.e7.delete(0, END)
        self.e7.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e8.config(state=NORMAL)
        self.e8.delete(0, END)
        self.e8.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e9.config(state=NORMAL)
        self.e9.delete(0, END)
        self.e9.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e10.config(state=NORMAL)
        self.e10.delete(0, END)
        self.e10.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e11.config(state=NORMAL)
        self.e11.delete(0, END)
        self.e11.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e12.config(state=NORMAL)
        self.e12.delete(0, END)
        self.e12.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e13.config(state=NORMAL)
        self.e13.delete(0, END)
        self.e13.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e14.config(state=NORMAL)
        self.e14.delete(0, END)
        self.e14.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e15.config(state=NORMAL)
        self.e15.delete(0, END)
        self.e15.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e16.config(state=NORMAL)
        self.e16.delete(0, END)
        self.e16.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e17.config(state=NORMAL)
        self.e17.delete(0, END)
        self.e17.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e18.config(state=NORMAL)
        self.e18.delete(0, END)
        self.e18.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e19.config(state=NORMAL)
        self.e19.delete(0, END)
        self.e19.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e20.config(state=NORMAL)
        self.e20.delete(0, END)
        self.e20.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e21.config(state=NORMAL)
        self.e21.delete(0, END)
        self.e21.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e22.config(state=NORMAL)
        self.e22.delete(0, END)
        self.e22.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e23.config(state=NORMAL)
        self.e23.delete(0, END)
        self.e23.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e24.config(state=NORMAL)
        self.e24.delete(0, END)
        self.e24.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e25.config(state=NORMAL)
        self.e25.delete(0, END)
        self.e25.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e26.config(state=NORMAL)
        self.e26.delete(0, END)
        self.e26.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e27.config(state=NORMAL)
        self.e27.delete(0, END)
        self.e27.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e28.config(state=NORMAL)
        self.e28.delete(0, END)
        self.e28.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e29.config(state=NORMAL)
        self.e29.delete(0, END)
        self.e29.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e30.config(state=NORMAL)
        self.e30.delete(0, END)
        self.e30.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e31.config(state=NORMAL)
        self.e31.delete(0, END)
        self.e31.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e32.config(state=NORMAL)
        self.e32.delete(0, END)
        self.e32.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e33.config(state=NORMAL)
        self.e33.delete(0, END)
        self.e33.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e34.config(state=NORMAL)
        self.e34.delete(0, END)
        self.e34.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e35.config(state=NORMAL)
        self.e35.delete(0, END)
        self.e35.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e36.config(state=NORMAL)
        self.e36.delete(0, END)
        self.e36.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e37.config(state=NORMAL)
        self.e37.delete(0, END)
        self.e37.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e38.config(state=NORMAL)
        self.e38.delete(0, END)
        self.e38.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e39.config(state=NORMAL)
        self.e39.delete(0, END)
        self.e39.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e40.config(state=NORMAL)
        self.e40.delete(0, END)
        self.e40.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e41.config(state=NORMAL)
        self.e41.delete(0, END)
        self.e41.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e42.config(state=NORMAL)
        self.e42.delete(0, END)
        self.e42.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e43.config(state=NORMAL)
        self.e43.delete(0, END)
        self.e43.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e44.config(state=NORMAL)
        self.e44.delete(0, END)
        self.e44.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)

##############################################################################################
        global linkeSeite
        linkeSeite = 'li'
        global rechteSeite
        rechteSeite = 're'

    def Oxidationsteilgleichung(self):
        global li_Redm1_OZ1
        global li_Redm1_KO1
        global li_Redm1_SF1
        global li_LA_KO1
        global li_LA_SF1
        global li_SA_KO1
        global li_SA_SF1
        global re_Oxm1_OZ1
        global re_Oxm1_KO1
        global re_Oxm1_SF1
        global re_EA_KO1
        global re_EA_SF1
        global re_LA_KO1
        global re_LA_SF1
        global re_SA_KO1
        global re_SA_SF1
        li_Redm1_OZ1 = redm1[Reduktionsmittel1][Oxidationsmittel1][Milieu]['li']['Redm1_OZ']
        li_Redm1_KO1 = redm1[Reduktionsmittel1][Oxidationsmittel1][Milieu]['li']['Redm1_KO']
        li_Redm1_SF1 = redm1[Reduktionsmittel1][Oxidationsmittel1][Milieu]['li']['Redm1_SF']
        li_LA_KO1 = redm1[Reduktionsmittel1][Oxidationsmittel1][Milieu]['li']['LA_KO']
        li_LA_SF1 = redm1[Reduktionsmittel1][Oxidationsmittel1][Milieu]['li']['LA_SF']
        li_SA_KO1 = redm1[Reduktionsmittel1][Oxidationsmittel1][Milieu]['li']['SA_KO']
        li_SA_SF1 = redm1[Reduktionsmittel1][Oxidationsmittel1][Milieu]['li']['SA_SF']
        re_Oxm1_OZ1 = redm1[Reduktionsmittel1][Oxidationsmittel1][Milieu]['re']['Oxm1_OZ']
        re_Oxm1_KO1 = redm1[Reduktionsmittel1][Oxidationsmittel1][Milieu]['re']['Oxm1_KO']
        re_Oxm1_SF1 = redm1[Reduktionsmittel1][Oxidationsmittel1][Milieu]['re']['Oxm1_SF']
        re_EA_KO1 = redm1[Reduktionsmittel1][Oxidationsmittel1][Milieu]['re']['EA_KO']
        re_EA_SF1 = redm1[Reduktionsmittel1][Oxidationsmittel1][Milieu]['re']['EA_SF']
        re_LA_KO1 = redm1[Reduktionsmittel1][Oxidationsmittel1][Milieu]['re']['LA_KO']
        re_LA_SF1 = redm1[Reduktionsmittel1][Oxidationsmittel1][Milieu]['re']['LA_SF']
        re_SA_KO1 = redm1[Reduktionsmittel1][Oxidationsmittel1][Milieu]['re']['SA_KO']
        re_SA_SF1 = redm1[Reduktionsmittel1][Oxidationsmittel1][Milieu]['re']['SA_SF']
        #print '# Oxidationsteilgleichung:\n',li_Redm1_KO1,li_Redm1_SF1,li_LA_KO1,li_LA_SF1,li_SA_KO1,li_SA_SF1,' -> ',re_Oxm1_KO1,re_Oxm1_SF1,re_EA_KO1,re_EA_SF1,re_LA_KO1,re_LA_SF1,re_SA_KO1,re_SA_SF1
        #print u'# Die OZ erh\xf6ht sich von',li_Redm1_OZ1,'auf',re_Oxm1_OZ1
        self.e1.config(state=NORMAL)
        self.e1.insert(0, li_Redm1_KO1)
        self.e1.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e2.config(state=NORMAL)
        self.e2.insert(0, li_Redm1_SF1)
        self.e2.config(state=DISABLED, disabledbackground='darkgreen', disabledforeground='white')
        self.e3.config(state=NORMAL)
        self.e3.insert(0, li_LA_KO1)
        self.e3.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e4.config(state=NORMAL)
        self.e4.insert(0, li_LA_SF1)
        self.e4.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e5.config(state=NORMAL)
        self.e5.insert(0, li_SA_KO1)
        self.e5.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e6.config(state=NORMAL)
        self.e6.insert(0, li_SA_SF1)
        self.e6.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e7.config(state=NORMAL)
        self.e7.insert(0, re_Oxm1_KO1)
        self.e7.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e8.config(state=NORMAL)
        self.e8.insert(0, re_Oxm1_SF1)
        self.e8.config(state=DISABLED, disabledbackground='darkred', disabledforeground='white')
        self.e9.config(state=NORMAL)
        self.e9.insert(0, re_EA_KO1)
        self.e9.config(state=DISABLED, disabledbackground='white', disabledforeground='darkorange')
        self.e10.config(state=NORMAL)
        self.e10.insert(0, re_EA_SF1)
        self.e10.config(state=DISABLED, disabledbackground='white', disabledforeground='darkorange')
        self.e11.config(state=NORMAL)
        self.e11.insert(0, re_LA_KO1)
        self.e11.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e12.config(state=NORMAL)
        self.e12.insert(0, re_LA_SF1)
        self.e12.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e41.config(state=NORMAL)
        self.e41.insert(0, re_SA_KO1)
        self.e41.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e42.config(state=NORMAL)
        self.e42.insert(0, re_SA_SF1)
        self.e42.config(state=DISABLED, disabledbackground='white', disabledforeground='black')


    def Reduktionsteilgleichung(self):
        global li_Oxm2_OZ2
        global li_Oxm2_KO2
        global li_Oxm2_SF2
        global li_EA_KO2
        global li_EA_SF2
        global li_LA_KO2
        global li_LA_SF2
        global li_SA_KO2
        global li_SA_SF2
        global re_Redm2_OZ2
        global re_Redm2_KO2
        global re_Redm2_SF2
        global re_LA_KO2
        global re_LA_SF2
        global re_SA_KO2
        global re_SA_SF2
        li_Oxm2_OZ2 = redm1[Reduktionsmittel2][Oxidationsmittel2][Milieu]['re']['Oxm1_OZ']
        li_Oxm2_KO2 = redm1[Reduktionsmittel2][Oxidationsmittel2][Milieu]['re']['Oxm1_KO']
        li_Oxm2_SF2 = redm1[Reduktionsmittel2][Oxidationsmittel2][Milieu]['re']['Oxm1_SF']
        li_EA_KO2 = redm1[Reduktionsmittel2][Oxidationsmittel2][Milieu]['re']['EA_KO']
        li_EA_SF2 = redm1[Reduktionsmittel2][Oxidationsmittel2][Milieu]['re']['EA_SF']
        li_LA_KO2 = redm1[Reduktionsmittel2][Oxidationsmittel2][Milieu]['re']['LA_KO']
        li_LA_SF2 = redm1[Reduktionsmittel2][Oxidationsmittel2][Milieu]['re']['LA_SF']
        li_SA_KO2 = redm1[Reduktionsmittel2][Oxidationsmittel2][Milieu]['re']['SA_KO']
        li_SA_SF2 = redm1[Reduktionsmittel2][Oxidationsmittel2][Milieu]['re']['SA_SF']
        re_Redm2_OZ2 = redm1[Reduktionsmittel2][Oxidationsmittel2][Milieu]['li']['Redm1_OZ']
        re_Redm2_KO2 = redm1[Reduktionsmittel2][Oxidationsmittel2][Milieu]['li']['Redm1_KO']
        re_Redm2_SF2 = redm1[Reduktionsmittel2][Oxidationsmittel2][Milieu]['li']['Redm1_SF']
        re_LA_KO2 = redm1[Reduktionsmittel2][Oxidationsmittel2][Milieu]['li']['LA_KO']
        re_LA_SF2 = redm1[Reduktionsmittel2][Oxidationsmittel2][Milieu]['li']['LA_SF']
        re_SA_KO2 = redm1[Reduktionsmittel2][Oxidationsmittel2][Milieu]['li']['SA_KO']
        re_SA_SF2 = redm1[Reduktionsmittel2][Oxidationsmittel2][Milieu]['li']['SA_SF']
        #print '# Reduktionsteilgleichung:\n',li_Oxm2_KO2,li_Oxm2_SF2,li_EA_KO2,li_EA_SF2,li_LA_KO2,li_LA_SF2,li_SA_KO2,li_SA_SF2,' -> ',re_Redm2_KO2,re_Redm2_SF2,re_LA_KO2,re_LA_SF2,re_SA_KO2,re_SA_SF2
        #print '# Die OZ erniedrigt sich von',li_Oxm2_OZ2,'auf',re_Redm2_OZ2
        self.e13.config(state=NORMAL)
        self.e13.insert(0, li_Oxm2_KO2)
        self.e13.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e14.config(state=NORMAL)
        self.e14.insert(0, li_Oxm2_SF2)
        self.e14.config(state=DISABLED, disabledbackground='darkred', disabledforeground='white')
        self.e15.config(state=NORMAL)
        self.e15.insert(0, li_EA_KO2)
        self.e15.config(state=DISABLED, disabledbackground='white', disabledforeground='darkorange')
        self.e16.config(state=NORMAL)
        self.e16.insert(0, li_EA_SF2)
        self.e16.config(state=DISABLED, disabledbackground='white', disabledforeground='darkorange')
        self.e17.config(state=NORMAL)
        self.e17.insert(0, li_LA_KO2)
        self.e17.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e18.config(state=NORMAL)
        self.e18.insert(0, li_LA_SF2)
        self.e18.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e43.config(state=NORMAL)
        self.e43.insert(0, li_SA_KO2)
        self.e43.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e44.config(state=NORMAL)
        self.e44.insert(0, li_SA_SF2)
        self.e44.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e19.config(state=NORMAL)
        self.e19.insert(0, re_Redm2_KO2)
        self.e19.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e20.config(state=NORMAL)
        self.e20.insert(0, re_Redm2_SF2)
        self.e20.config(state=DISABLED, disabledbackground='darkgreen', disabledforeground='white')
        self.e21.config(state=NORMAL)
        self.e21.insert(0, re_LA_KO2)
        self.e21.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e22.config(state=NORMAL)
        self.e22.insert(0, re_LA_SF2)
        self.e22.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e23.config(state=NORMAL)
        self.e23.insert(0, re_SA_KO2)
        self.e23.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e24.config(state=NORMAL)
        self.e24.insert(0, re_SA_SF2)
        self.e24.config(state=DISABLED, disabledbackground='white', disabledforeground='black')

    def Gesamtgleichung(self):
        def ggT(x, y):
            if y == 0 :
                return x
            else:
                return ggT(y, x % y)
        ## Ermitteln des KGV der Zahl der uebergegangenen Elektronen in den beiden Teilgleichungen
        a = int(re_EA_KO1)
        b = int(li_EA_KO2)
        GGT = ggT(a, b)
        #print 'GGT =',GGT
        KGV = a*b/ggT(a, b)
        #print 'KVG =',KGV
        # Faktor fuer a
        Fa = KGV/a
        #print 'Ausgleichsfaktor fuer die Reduktionsteilgleichung =',Fa
        # Faktor fuer b
        Fb = KGV/b
        #print 'Ausgleichsfaktor fuer die Oxidationsteilgleichung =',Fb
        try:
            li_LA_KO_01=int(Fa)*int(li_LA_KO1)
        except:
            li_LA_KO_01=int(0)
        try:
            li_LA_KO_02=int(Fb)*int(li_LA_KO2)
        except:
            li_LA_KO_02=int(0)
        li_LA_KO=int(li_LA_KO_01)+int(li_LA_KO_02)
        try:
            li_SA_KO_01=int(Fa)*int(li_SA_KO1)    
        except:
            li_SA_KO_01=int(0)
        try:
            li_SA_KO_02=int(Fb)*int(li_SA_KO2)
        except:
            li_SA_KO_02=int(0)
        li_SA_KO=int(li_SA_KO_01)+int(li_SA_KO_02)
        try:
            re_LA_KO_01=int(Fa)*int(re_LA_KO1)
        except:
            re_LA_KO_01=int(0)
        try:
            re_LA_KO_02=int(Fb)*int(re_LA_KO2)
        except:
            re_LA_KO_02=int(0)
        re_LA_KO=int(re_LA_KO_01)+int(re_LA_KO_02)
        try:
            re_SA_KO_01=int(Fa)*int(re_SA_KO1)
        except:
            re_SA_KO_01=int(0)
        try:
            re_SA_KO_02=int(Fb)*int(re_SA_KO2)
        except:
            re_SA_KO_02=int(0)
        re_SA_KO=int(re_SA_KO_01)+int(re_SA_KO_02)
        if Milieu == 'sauer':
            LA_SF=u'H\u2083O\u207A'
        if Milieu == 'alkalisch':
            LA_SF=u'OH\u207B'

        Gesamtgleichung = '%s%s + %s%s + %s%s + %s%s  -> %s%s + %s%s + %s%s + %s%s' \
                           %(int(Fa)*int(li_Redm1_KO1), li_Redm1_SF1, \
                             int(Fb)*int(li_Oxm2_KO2), li_Oxm2_SF2, \
                             li_LA_KO, LA_SF, \
                             li_SA_KO, u'H\u2082O', \
                             int(Fa)*int(re_Oxm1_KO1), re_Oxm1_SF1, \
                             int(Fb)*int(re_Redm2_KO2), re_Redm2_SF2, \
                             re_LA_KO, LA_SF, \
                             re_SA_KO, u'H\u2082O')
        #print Gesamtgleichung
        ## links
        global ges_li_Redm1_KO1
        ges_li_Redm1_KO1=int(Fa)*int(li_Redm1_KO1)
        self.e25.config(state=NORMAL)
        self.e25.insert(0, ges_li_Redm1_KO1)
        self.e25.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e26.config(state=NORMAL)
        self.e26.insert(0, li_Redm1_SF1)
        self.e26.config(state=DISABLED, disabledbackground='darkgreen', disabledforeground='white')
        global ges_li_Oxm2_KO2
        ges_li_Oxm2_KO2=int(Fb)*int(li_Oxm2_KO2)
        self.e27.config(state=NORMAL)
        self.e27.insert(0, ges_li_Oxm2_KO2)
        self.e27.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e28.config(state=NORMAL)
        self.e28.insert(0, li_Oxm2_SF2)
        self.e28.config(state=DISABLED, disabledbackground='darkred', disabledforeground='white')
        self.e29.config(state=NORMAL)
        if li_LA_KO != '0':
            self.e29.insert(0, li_LA_KO)
        self.e29.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e30.config(state=NORMAL)
        if li_LA_KO != '0':
            self.e30.insert(0, LA_SF)
        self.e30.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e31.config(state=NORMAL)
        if li_SA_KO != '0':
            self.e31.insert(0, li_SA_KO)
        self.e31.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e32.config(state=NORMAL)
        if li_SA_KO != '0':
            self.e32.insert(0, u'H\u2082O')
        self.e32.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        ## rechts
        global ges_re_Oxm1_KO1
        ges_re_Oxm1_KO1=int(Fa)*int(re_Oxm1_KO1)
        self.e33.config(state=NORMAL)
        self.e33.insert(0, ges_re_Oxm1_KO1)
        self.e33.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e34.config(state=NORMAL)
        self.e34.insert(0, re_Oxm1_SF1)
        self.e34.config(state=DISABLED, disabledbackground='darkred', disabledforeground='white')
        global ges_re_Redm2_KO2
        ges_re_Redm2_KO2=int(Fb)*int(re_Redm2_KO2)
        self.e35.config(state=NORMAL)
        self.e35.insert(0, ges_re_Redm2_KO2)
        self.e35.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e36.config(state=NORMAL)
        self.e36.insert(0, re_Redm2_SF2)
        self.e36.config(state=DISABLED, disabledbackground='darkgreen', disabledforeground='white')
        self.e37.config(state=NORMAL)
        if re_LA_KO != '0':
            self.e37.insert(0, re_LA_KO)
        self.e37.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e38.config(state=NORMAL)
        if re_LA_KO != '0':
            self.e38.insert(0, LA_SF)
        self.e38.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e39.config(state=NORMAL)
        if re_SA_KO != '0':
            self.e39.insert(0, re_SA_KO)
        self.e39.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        self.e40.config(state=NORMAL)
        if re_SA_KO != '0':
            self.e40.insert(0, u'H\u2082O')
        self.e40.config(state=DISABLED, disabledbackground='white', disabledforeground='black')
        #Leere Felder ausgrauen
        global Testvariable
        self.e3.config(state=NORMAL)
        Testvariable=self.e3.get()
        if len(Testvariable) == 0 :
            self.e3.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e4.config(state=NORMAL)
        Testvariable=self.e4.get()
        if len(Testvariable) == 0 :
            self.e4.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e5.config(state=NORMAL)
        Testvariable=self.e5.get()
        if len(Testvariable) == 0 :
            self.e5.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e6.config(state=NORMAL)
        Testvariable=self.e6.get()
        if len(Testvariable) == 0 :
            self.e6.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e11.config(state=NORMAL)
        Testvariable=self.e11.get()
        if len(Testvariable) == 0 :
            self.e11.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e12.config(state=NORMAL)
        Testvariable=self.e12.get()
        if len(Testvariable) == 0 :
            self.e12.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e41.config(state=NORMAL)
        Testvariable=self.e41.get()
        if len(Testvariable) == 0 :
            self.e41.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e42.config(state=NORMAL)
        Testvariable=self.e42.get()
        if len(Testvariable) == 0 :
            self.e42.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e17.config(state=NORMAL)
        Testvariable=self.e17.get()
        if len(Testvariable) == 0 :
            self.e17.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e18.config(state=NORMAL)
        Testvariable=self.e18.get()
        if len(Testvariable) == 0 :
            self.e18.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e43.config(state=NORMAL)
        Testvariable=self.e43.get()
        if len(Testvariable) == 0 :
            self.e43.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e44.config(state=NORMAL)
        Testvariable=self.e44.get()
        if len(Testvariable) == 0 :
            self.e44.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e21.config(state=NORMAL)
        Testvariable=self.e21.get()
        if len(Testvariable) == 0 :
            self.e21.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e22.config(state=NORMAL)
        Testvariable=self.e22.get()
        if len(Testvariable) == 0 :
            self.e22.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e23.config(state=NORMAL)
        Testvariable=self.e23.get()
        if len(Testvariable) == 0 :
            self.e23.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e24.config(state=NORMAL)
        Testvariable=self.e24.get()
        if len(Testvariable) == 0 :
            self.e24.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e29.config(state=NORMAL)
        Testvariable=self.e29.get()
        if len(Testvariable) == 0 :
            self.e29.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e30.config(state=NORMAL)
        Testvariable=self.e30.get()
        if len(Testvariable) == 0 :
            self.e30.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e31.config(state=NORMAL)
        Testvariable=self.e31.get()
        if len(Testvariable) == 0 :
            self.e31.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e32.config(state=NORMAL)
        Testvariable=self.e32.get()
        if len(Testvariable) == 0 :
            self.e32.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e37.config(state=NORMAL)
        Testvariable=self.e37.get()
        if len(Testvariable) == 0 :
            self.e37.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e38.config(state=NORMAL)
        Testvariable=self.e38.get()
        if len(Testvariable) == 0 :
            self.e38.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e39.config(state=NORMAL)
        Testvariable=self.e39.get()
        if len(Testvariable) == 0 :
            self.e39.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        self.e40.config(state=NORMAL)
        Testvariable=self.e40.get()
        if len(Testvariable) == 0 :
            self.e40.config(state=DISABLED, disabledbackground=EntryDefClr, disabledforeground=EntryFontClr)
        
##############################################################################################
root = Tk()
root.title('Oxidaser')
app = Fenster(root)
root.mainloop()
